﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Threading;

namespace TaskManager
{
    //扩展下所有Control类，把线程操作Invoke提出来。 
    public static class ControlExtended
    {

        public delegate void InvokeHandler();

        public static void UIInvoke(this Control control, InvokeHandler handler)
        {
            if (!control.Dispatcher.CheckAccess())
            {
                control.Dispatcher.Invoke(handler);
            }
            else
            {
                handler();
            }
        }

      

        public static T UIInvoke<T>(Func<T> handler)
        {
            if (Application.Current == null)
                return default(T); ;
            Dispatcher dispatcher = Application.Current.Dispatcher;
            if (dispatcher == null)
                return default(T);
            if (!dispatcher.CheckAccess())
            {
                return (T) dispatcher.Invoke(handler);
            }
            return handler.Invoke();
        }

        public static void UIInvoke(Action handler)
        {
            if (Application.Current == null)
                return;
            Dispatcher dispatcher = Application.Current.Dispatcher;
            if(dispatcher==null)
             return;
            if (!dispatcher.CheckAccess())
            {
                dispatcher.Invoke(handler);
            }
            else
            {
                handler.Invoke();
            }
        }

        public static void UIBeginInvoke(Action handler)
        {
            if(Application.Current==null)
                return;
            Dispatcher dispatcher = Application.Current.Dispatcher;
          
            if (!dispatcher.CheckAccess())
            {
                dispatcher.BeginInvoke(handler);
            }
            else
            {
                handler.Invoke();
            }
        }

        
    }
}